Ausnahmebehandlung in Java

1. Übersicht

In diesem Tutorial werden die Grundlagen der Ausnahmebehandlung in Java sowie einige seiner Fallstricke erläutert.

2. Erste Prinzipien

2.1. Was ist es?

Um Ausnahmen und die Ausnahmebehandlung besser zu verstehen, führen wir einen realen Vergleich durch.

Stellen Sie sich vor, wir bestellen ein Produkt online, aber unterwegs ist die Lieferung fehlerhaft. Ein gutes Unternehmen kann dieses Problem lösen und unser Paket ordnungsgemäß umleiten, damit es immer noch pünktlich ankommt.

Ebenso kann es in Java beim Ausführen unserer Anweisungen zu Fehlern im Code kommen. Eine gute Ausnahmebehandlung kann Fehler behandeln und das Programm ordnungsgemäß umleiten, um dem Benutzer dennoch eine positive Erfahrung zu bieten .

2.2. Warum es benutzen?

Normalerweise schreiben wir Code in einer idealisierten Umgebung: Das Dateisystem enthält immer unsere Dateien, das Netzwerk ist fehlerfrei und die JVM verfügt immer über genügend Speicher. Manchmal nennen wir dies den „glücklichen Weg“.

In der Produktion können Dateisysteme jedoch beschädigt werden, Netzwerke ausfallen und JVMs verfügen nicht über genügend Arbeitsspeicher. Das Wohlbefinden unseres Codes hängt davon ab, wie er mit „unglücklichen Pfaden“ umgeht.

Wir müssen mit diesen Bedingungen umgehen, da sie den Ablauf der Anwendung negativ beeinflussen und Ausnahmen bilden :

public static List getPlayers() throws IOException { Path path = Paths.get("players.dat"); List players = Files.readAllLines(path); return players.stream() .map(Player::new) .collect(Collectors.toList()); }

Dieser Code behandelt die IOException nicht und leitet sie stattdessen an den Aufrufstapel weiter. In einer idealisierten Umgebung funktioniert der Code einwandfrei.

Aber was kann in der Produktion passieren, wenn player.dat fehlt?

Exception in thread "main" java.nio.file.NoSuchFileException: players.dat <-- players.dat file doesn't exist at sun.nio.fs.WindowsException.translateToIOException(Unknown Source) at sun.nio.fs.WindowsException.rethrowAsIOException(Unknown Source) // ... more stack trace at java.nio.file.Files.readAllLines(Unknown Source) at java.nio.file.Files.readAllLines(Unknown Source) at Exceptions.getPlayers(Exceptions.java:12) <-- Exception arises in getPlayers() method, on line 12 at Exceptions.main(Exceptions.java:19) <-- getPlayers() is called by main(), on line 19

Ohne diese Ausnahme kann ein ansonsten fehlerfreies Programm möglicherweise nicht mehr ausgeführt werden! Wir müssen sicherstellen, dass unser Code einen Plan hat, wann etwas schief geht.

Beachten Sie auch einen weiteren Vorteil für Ausnahmen, und das ist die Stapelverfolgung selbst. Aufgrund dieser Stapelverfolgung können wir häufig fehlerhaften Code lokalisieren, ohne einen Debugger anhängen zu müssen.

3. Ausnahmehierarchie

Letztendlich sind Ausnahmen nur Java-Objekte, die sich alle von Throwable erstrecken :

 ---> Throwable  Exception Error | (checked) (unchecked) | RuntimeException (unchecked)

Es gibt drei Hauptkategorien außergewöhnlicher Bedingungen:

  • Überprüfte Ausnahmen
  • Deaktivierte Ausnahmen / Laufzeitausnahmen
  • Fehler

Laufzeit- und ungeprüfte Ausnahmen beziehen sich auf dasselbe. Wir können sie oft austauschbar verwenden.

3.1. Überprüfte Ausnahmen

Überprüfte Ausnahmen sind Ausnahmen, die der Java-Compiler von uns verlangt. Wir müssen die Ausnahme entweder deklarativ in den Aufrufstapel werfen oder sie selbst behandeln. Mehr dazu gleich.

In der Dokumentation von Oracle wird empfohlen, geprüfte Ausnahmen zu verwenden, wenn wir vernünftigerweise erwarten können, dass der Aufrufer unserer Methode wiederhergestellt werden kann.

Einige Beispiele für geprüfte Ausnahmen sind IOException und ServletException.

3.2. Deaktivierte Ausnahmen

Nicht aktivierte Ausnahmen sind Ausnahmen, die vom Java-Compiler nicht behandelt werden müssen.

Einfach ausgedrückt, wenn wir eine Ausnahme erstellen, die RuntimeException erweitert , wird sie deaktiviert . Andernfalls wird es überprüft.

Obwohl dies praktisch klingt, gibt es in der Dokumentation von Oracle gute Gründe für beide Konzepte, z. B. die Unterscheidung zwischen einem Situationsfehler (aktiviert) und einem Verwendungsfehler (deaktiviert).

Einige Beispiele für nicht aktivierte Ausnahmen sind NullPointerException, IllegalArgumentException und SecurityException .

3.3. Fehler

Fehler stellen schwerwiegende und normalerweise nicht behebbare Zustände dar, wie z. B. eine Inkompatibilität der Bibliothek, eine unendliche Rekursion oder Speicherlecks.

Und obwohl sie RuntimeException nicht erweitern , sind sie auch deaktiviert .

In den meisten Fällen wäre es seltsam für uns, Fehler zu behandeln, zu instanziieren oder zu erweitern . Normalerweise möchten wir, dass sich diese bis ganz nach oben ausbreiten.

Ein paar Beispiele für Fehler sind eine Stackoverflow und OutOfMemoryError .

4. Umgang mit Ausnahmen

In der Java-API gibt es viele Stellen, an denen Fehler auftreten können, und einige dieser Stellen sind mit Ausnahmen gekennzeichnet, entweder in der Signatur oder im Javadoc:

/** * @exception FileNotFoundException ... */ public Scanner(String fileName) throws FileNotFoundException { // ... }

Wie schon etwas früher gesagt, wenn wir diese „riskanten“ Methoden aufrufen, wir müssen behandeln die Ausnahmen geprüft, und wir können die nicht markiert diejenigen behandeln. Java bietet uns verschiedene Möglichkeiten, dies zu tun:

4.1. wirft

Der einfachste Weg, eine Ausnahme zu „behandeln“, besteht darin, sie erneut zu werfen:

public int getPlayerScore(String playerFile) throws FileNotFoundException { Scanner contents = new Scanner(new File(playerFile)); return Integer.parseInt(contents.nextLine()); }

Da FileNotFoundException eine aktivierte Ausnahme ist, ist dies der einfachste Weg, um den Compiler zufrieden zu stellen. Dies bedeutet jedoch, dass jeder, der unsere Methode aufruft, jetzt auch damit umgehen muss!

parseInt kann eine NumberFormatException auslösen , aber da diese deaktiviert ist, müssen wir sie nicht verarbeiten.

4.2. versuchen zu fangen

Wenn wir versuchen möchten, die Ausnahme selbst zu behandeln, können wir einen Try-Catch- Block verwenden. Wir können damit umgehen, indem wir unsere Ausnahme erneut auslösen:

public int getPlayerScore(String playerFile) { try { Scanner contents = new Scanner(new File(playerFile)); return Integer.parseInt(contents.nextLine()); } catch (FileNotFoundException noFile) { throw new IllegalArgumentException("File not found"); } }

Oder indem Sie Wiederherstellungsschritte ausführen:

public int getPlayerScore(String playerFile) { try { Scanner contents = new Scanner(new File(playerFile)); return Integer.parseInt(contents.nextLine()); } catch ( FileNotFoundException noFile ) { logger.warn("File not found, resetting score."); return 0; } }

4.3. schließlich

Es gibt Zeiten, in denen Code ausgeführt werden muss, unabhängig davon, ob eine Ausnahme auftritt, und hier kommt das Schlüsselwort finally ins Spiel.

In our examples so far, there ‘s been a nasty bug lurking in the shadows, which is that Java by default won't return file handles to the operating system.

Certainly, whether we can read the file or not, we want to make sure that we do the appropriate cleanup!

Let's try this the “lazy” way first:

public int getPlayerScore(String playerFile) throws FileNotFoundException { Scanner contents = null; try { contents = new Scanner(new File(playerFile)); return Integer.parseInt(contents.nextLine()); } finally { if (contents != null) { contents.close(); } } } 

Here, the finally block indicates what code we want Java to run regardless of what happens with trying to read the file.

Even if a FileNotFoundException is thrown up the call stack, Java will call the contents of finally before doing that.

We can also both handle the exception and make sure that our resources get closed:

public int getPlayerScore(String playerFile) { Scanner contents; try { contents = new Scanner(new File(playerFile)); return Integer.parseInt(contents.nextLine()); } catch (FileNotFoundException noFile ) { logger.warn("File not found, resetting score."); return 0; } finally { try { if (contents != null) { contents.close(); } } catch (IOException io) { logger.error("Couldn't close the reader!", io); } } }

Because close is also a “risky” method, we also need to catch its exception!

This may look pretty complicated, but we need each piece to handle each potential problem that can arise correctly.

4.4. try-with-resources

Fortunately, as of Java 7, we can simplify the above syntax when working with things that extend AutoCloseable:

public int getPlayerScore(String playerFile) { try (Scanner contents = new Scanner(new File(playerFile))) { return Integer.parseInt(contents.nextLine()); } catch (FileNotFoundException e ) { logger.warn("File not found, resetting score."); return 0; } }

When we place references that are AutoClosable in the try declaration, then we don't need to close the resource ourselves.

We can still use a finally block, though, to do any other kind of cleanup we want.

Check out our article dedicated to try-with-resources to learn more.

4.5. Multiple catch Blocks

Sometimes, the code can throw more than one exception, and we can have more than one catch block handle each individually:

public int getPlayerScore(String playerFile) { try (Scanner contents = new Scanner(new File(playerFile))) { return Integer.parseInt(contents.nextLine()); } catch (IOException e) { logger.warn("Player file wouldn't load!", e); return 0; } catch (NumberFormatException e) { logger.warn("Player file was corrupted!", e); return 0; } }

Multiple catches give us the chance to handle each exception differently, should the need arise.

Also note here that we didn't catch FileNotFoundException, and that is because it extends IOException. Because we're catching IOException, Java will consider any of its subclasses also handled.

Let's say, though, that we need to treat FileNotFoundException differently from the more general IOException:

public int getPlayerScore(String playerFile) { try (Scanner contents = new Scanner(new File(playerFile)) ) { return Integer.parseInt(contents.nextLine()); } catch (FileNotFoundException e) { logger.warn("Player file not found!", e); return 0; } catch (IOException e) { logger.warn("Player file wouldn't load!", e); return 0; } catch (NumberFormatException e) { logger.warn("Player file was corrupted!", e); return 0; } }

Java lets us handle subclass exceptions separately, remember to place them higher in the list of catches.

4.6. Union catch Blocks

When we know that the way we handle errors is going to be the same, though, Java 7 introduced the ability to catch multiple exceptions in the same block:

public int getPlayerScore(String playerFile) { try (Scanner contents = new Scanner(new File(playerFile))) { return Integer.parseInt(contents.nextLine()); } catch (IOException | NumberFormatException e) { logger.warn("Failed to load score!", e); return 0; } }

5. Throwing Exceptions

If we don't want to handle the exception ourselves or we want to generate our exceptions for others to handle, then we need to get familiar with the throw keyword.

Let's say that we have the following checked exception we've created ourselves:

public class TimeoutException extends Exception { public TimeoutException(String message) { super(message); } }

and we have a method that could potentially take a long time to complete:

public List loadAllPlayers(String playersFile) { // ... potentially long operation }

5.1. Throwing a Checked Exception

Like returning from a method, we can throw at any point.

Of course, we should throw when we are trying to indicate that something has gone wrong:

public List loadAllPlayers(String playersFile) throws TimeoutException { while ( !tooLong ) { // ... potentially long operation } throw new TimeoutException("This operation took too long"); }

Because TimeoutException is checked, we also must use the throws keyword in the signature so that callers of our method will know to handle it.

5.2. Throwing an Unchecked Exception

If we want to do something like, say, validate input, we can use an unchecked exception instead:

public List loadAllPlayers(String playersFile) throws TimeoutException { if(!isFilenameValid(playersFile)) { throw new IllegalArgumentException("Filename isn't valid!"); } // ... } 

Because IllegalArgumentException is unchecked, we don't have to mark the method, though we are welcome to.

Some mark the method anyway as a form of documentation.

5.3. Wrapping and Rethrowing

We can also choose to rethrow an exception we've caught:

public List loadAllPlayers(String playersFile) throws IOException { try { // ... } catch (IOException io) { throw io; } }

Or do a wrap and rethrow:

public List loadAllPlayers(String playersFile) throws PlayerLoadException { try { // ... } catch (IOException io) { throw new PlayerLoadException(io); } }

This can be nice for consolidating many different exceptions into one.

5.4. Rethrowing Throwable or Exception

Now for a special case.

If the only possible exceptions that a given block of code could raise are unchecked exceptions, then we can catch and rethrow Throwable or Exception without adding them to our method signature:

public List loadAllPlayers(String playersFile) { try { throw new NullPointerException(); } catch (Throwable t) { throw t; } }

While simple, the above code can't throw a checked exception and because of that, even though we are rethrowing a checked exception, we don't have to mark the signature with a throws clause.

This is handy with proxy classes and methods. More about this can be found here.

5.5. Inheritance

When we mark methods with a throws keyword, it impacts how subclasses can override our method.

In the circumstance where our method throws a checked exception:

public class Exceptions { public List loadAllPlayers(String playersFile) throws TimeoutException { // ... } }

A subclass can have a “less risky” signature:

public class FewerExceptions extends Exceptions { @Override public List loadAllPlayers(String playersFile) { // overridden } }

But not a “more riskier” signature:

public class MoreExceptions extends Exceptions { @Override public List loadAllPlayers(String playersFile) throws MyCheckedException { // overridden } }

This is because contracts are determined at compile time by the reference type. If I create an instance of MoreExceptions and save it to Exceptions:

Exceptions exceptions = new MoreExceptions(); exceptions.loadAllPlayers("file");

Then the JVM will only tell me to catch the TimeoutException, which is wrong since I've said that MoreExceptions#loadAllPlayers throws a different exception.

Simply put, subclasses can throw fewer checked exceptions than their superclass, but not more.

6. Anti-Patterns

6.1. Swallowing Exceptions

Now, there’s one other way that we could have satisfied the compiler:

public int getPlayerScore(String playerFile) { try { // ... } catch (Exception e) {} // <== catch and swallow return 0; }

The above is calledswallowing an exception. Most of the time, it would be a little mean for us to do this because it doesn't address the issue and it keeps other code from being able to address the issue, too.

There are times when there's a checked exception that we are confident will just never happen. In those cases, we should still at least add a comment stating that we intentionally ate the exception:

public int getPlayerScore(String playerFile) { try { // ... } catch (IOException e) { // this will never happen } }

Another way we can “swallow” an exception is to print out the exception to the error stream simply:

public int getPlayerScore(String playerFile) { try { // ... } catch (Exception e) { e.printStackTrace(); } return 0; }

We've improved our situation a bit by a least writing the error out somewhere for later diagnosis.

It'd be better, though, for us to use a logger:

public int getPlayerScore(String playerFile) { try { // ... } catch (IOException e) { logger.error("Couldn't load the score", e); return 0; } }

While it's very convenient for us to handle exceptions in this way, we need to make sure that we aren't swallowing important information that callers of our code could use to remedy the problem.

Finally, we can inadvertently swallow an exception by not including it as a cause when we are throwing a new exception:

public int getPlayerScore(String playerFile) { try { // ... } catch (IOException e) { throw new PlayerScoreException(); } } 

Here, we pat ourselves on the back for alerting our caller to an error, but we fail to include the IOException as the cause. Because of this, we've lost important information that callers or operators could use to diagnose the problem.

We'd be better off doing:

public int getPlayerScore(String playerFile) { try { // ... } catch (IOException e) { throw new PlayerScoreException(e); } }

Notice the subtle difference of including IOException as the cause of PlayerScoreException.

6.2. Using return in a finally Block

Another way to swallow exceptions is to return from the finally block. This is bad because, by returning abruptly, the JVM will drop the exception, even if it was thrown from by our code:

public int getPlayerScore(String playerFile) { int score = 0; try { throw new IOException(); } finally { return score; // <== the IOException is dropped } }

According to the Java Language Specification:

If execution of the try block completes abruptly for any other reason R, then the finally block is executed, and then there is a choice.

If the finally block completes normally, then the try statement completes abruptly for reason R.

If the finally block completes abruptly for reason S, then the try statement completes abruptly for reason S (and reason R is discarded).

6.3. Using throw in a finally Block

Similar to using return in a finally block, the exception thrown in a finally block will take precedence over the exception that arises in the catch block.

This will “erase” the original exception from the try block, and we lose all of that valuable information:

public int getPlayerScore(String playerFile) { try { // ... } catch ( IOException io ) { throw new IllegalStateException(io); // <== eaten by the finally } finally { throw new OtherException(); } }

6.4. Using throw as a goto

Some people also gave into the temptation of using throw as a goto statement:

public void doSomething() { try { // bunch of code throw new MyException(); // second bunch of code } catch (MyException e) { // third bunch of code } }

This is odd because the code is attempting to use exceptions for flow control as opposed to error handling.

7. Common Exceptions and Errors

Here are some common exceptions and errors that we all run into from time to time:

7.1. Checked Exceptions

  • IOException – This exception is typically a way to say that something on the network, filesystem, or database failed.

7.2. RuntimeExceptions

  • ArrayIndexOutOfBoundsException – this exception means that we tried to access a non-existent array index, like when trying to get index 5 from an array of length 3.
  • ClassCastException – this exception means that we tried to perform an illegal cast, like trying to convert a String into a List. We can usually avoid it by performing defensive instanceof checks before casting.
  • IllegalArgumentException – this exception is a generic way for us to say that one of the provided method or constructor parameters is invalid.
  • IllegalStateException – This exception is a generic way for us to say that our internal state, like the state of our object, is invalid.
  • NullPointerException – This exception means we tried to reference a null object. We can usually avoid it by either performing defensive null checks or by using Optional.
  • NumberFormatException – This exception means that we tried to convert a String into a number, but the string contained illegal characters, like trying to convert “5f3” into a number.

7.3. Errors

  • StackOverflowError - Diese Ausnahme bedeutet, dass der Stack-Trace zu groß ist. Dies kann manchmal in massiven Anwendungen vorkommen. Dies bedeutet jedoch normalerweise, dass in unserem Code eine unendliche Rekursion auftritt.
  • NoClassDefFoundError - Diese Ausnahme bedeutet, dass eine Klasse nicht geladen werden konnte, weil sie sich nicht im Klassenpfad befand oder weil die statische Initialisierung fehlgeschlagen war.
  • OutOfMemoryError - Diese Ausnahme bedeutet, dass für die JVM kein Speicher mehr verfügbar ist, um mehr Objekte zuzuweisen. Manchmal liegt dies an einem Speicherverlust.

8. Fazit

In diesem Artikel haben wir die Grundlagen der Ausnahmebehandlung sowie einige Beispiele für gute und schlechte Praktiken behandelt.

Wie immer finden Sie den gesamten Code in diesem Artikel auf GitHub!